// Generated by ReScript, PLEASE EDIT WITH CARE
'use strict';

var Jest = require("@glennsl/bs-jest/lib/js/src/jest.js");
var Curry = require("bs-platform/lib/js/curry.js");
var JestDom = require("bs-jest-dom/lib/js/src/JestDom.js");
var Caml_option = require("bs-platform/lib/js/caml_option.js");
var DomTestingLibrary = require("../src/DomTestingLibrary.js");

var render = (function(html) {
    const body = document.querySelector('body', document)
    body.innerHTML = html
    return body
  });

var renderWithDelay = (function(html, delay) {
    const body = document.querySelector('body')
    setTimeout(() => {
      body.innerHTML = html
    }, delay)
    return body
  });

function then_(promise, fn) {
  return promise.then(Curry.__1(fn));
}

var $$Promise = {
  then_: then_
};

Jest.test("getByLabel", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByLabelText(undefined, {
                            NAME: "Str",
                            VAL: "Title"
                          }, render("<label for=\"title\">Title</label><input type=\"text\" id=\"title\" />"))));
      }));

Jest.test("getByLabel (with exact as false)", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByLabelText(DomTestingLibrary.makeByLabelTextOptions(undefined, false, undefined, undefined), {
                            NAME: "Str",
                            VAL: "title"
                          }, render("<label for=\"title\">Title</label><input type=\"text\" id=\"title\" />"))));
      }));

Jest.test("getByText", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByText(undefined, render("<span>Hello world</span>"), {
                            NAME: "Str",
                            VAL: "Hello world"
                          })));
      }));

Jest.test("getByText (with exact as false)", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByText(DomTestingLibrary.makeByTextOptions(undefined, false, undefined, undefined, undefined), render("<span>Hello world</span>"), {
                            NAME: "Str",
                            VAL: "hello world"
                          })));
      }));

Jest.test("getAllByRole", (function (param) {
        return Jest.Expect.toHaveLength(3, Jest.Expect.expect(DomTestingLibrary.getAllByRole(undefined, {
                            NAME: "Str",
                            VAL: "option"
                          }, render("<select>\n    <option role=\"option\">Color Red</option>\n    <option role=\"option\">Color Green</option>\n    <option role=\"option\">Color Blue</option>\n  </select>"))));
      }));

Jest.test("queryAllByRole", (function (param) {
        return Jest.Expect.toHaveLength(3, Jest.Expect.expect(DomTestingLibrary.queryAllByRole(undefined, {
                            NAME: "Str",
                            VAL: "option"
                          }, render("<select>\n    <option role=\"option\">Color Red</option>\n    <option role=\"option\">Color Green</option>\n    <option role=\"option\">Color Blue</option>\n  </select>"))));
      }));

Jest.test("getByRole using regex", (function (param) {
        var options = DomTestingLibrary.makeOptionsWithRegex(undefined, undefined, Caml_option.some(new RegExp("color green", "i")), undefined);
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByRole(options, {
                            NAME: "Str",
                            VAL: "option"
                          }, render("<option role=\"option\">Color Green</option>"))));
      }));

Jest.test("getByRole using function", (function (param) {
        var options = DomTestingLibrary.makeOptionsWithFunction(undefined, undefined, (function (content, _element) {
                return content === "Color Green";
              }), undefined);
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByRole(options, {
                            NAME: "Str",
                            VAL: "option"
                          }, render("<option role=\"option\">Color Green</option>"))));
      }));

Jest.test("getByPlaceholderText", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByPlaceholderText(undefined, {
                            NAME: "Str",
                            VAL: "title"
                          }, render("<input type=\"text\" placeholder=\"title\" />"))));
      }));

Jest.test("getByPlaceholderText (with exact as false)", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByPlaceholderText(DomTestingLibrary.makeByPlaceholderTextOptions(false, undefined, undefined), {
                            NAME: "Str",
                            VAL: "title"
                          }, render("<input type=\"text\" placeholder=\"Title\" />"))));
      }));

Jest.test("getByDisplayValue", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByDisplayValue(undefined, {
                            NAME: "Str",
                            VAL: "Red"
                          }, render("<input type=\"text\" placeholder=\"title\" value=\"Red\" />"))));
      }));

Jest.test("getByDisplayValue (with exact as false)", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByDisplayValue(DomTestingLibrary.makeByDisplayValueOptions(false, undefined, undefined), {
                            NAME: "Str",
                            VAL: "red"
                          }, render("<input type=\"text\" placeholder=\"title\" value=\"Red\" />"))));
      }));

Jest.test("getByAltText", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByAltText(undefined, {
                            NAME: "Str",
                            VAL: "alt text example"
                          }, render("<img alt=\"alt text example\" />"))));
      }));

Jest.test("getByAltText (with exact as false)", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByAltText(DomTestingLibrary.makeByAltTextOptions(false, undefined, undefined), {
                            NAME: "Str",
                            VAL: "alt text example"
                          }, render("<img alt=\"alt text example\" />"))));
      }));

Jest.test("getByTitle", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByTitle(undefined, {
                            NAME: "Str",
                            VAL: "title example"
                          }, render("<span title=\"title example\" />"))));
      }));

Jest.test("getByTitle (with exact as false)", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByTitle(DomTestingLibrary.makeByTitleOptions(false, undefined, undefined), {
                            NAME: "Str",
                            VAL: "TITLE EXAMPLE"
                          }, render("<span title=\"title example\" />"))));
      }));

Jest.test("getByTestId", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByTestId(undefined, {
                            NAME: "Str",
                            VAL: "test-id"
                          }, render("<div data-testid=\"test-id\">Test ID</div>"))));
      }));

Jest.test("getByTestId (with exact as false)", (function (param) {
        return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByTestId(DomTestingLibrary.makeByTestIdOptions(false, undefined, undefined), {
                            NAME: "Str",
                            VAL: "test-id"
                          }, render("<div data-testid=\"TEST-ID\">Test ID</div>"))));
      }));

Jest.testPromise("findByLabel", undefined, (function (param) {
        var promise = DomTestingLibrary.findByLabelText(undefined, {
              NAME: "Str",
              VAL: "Title"
            }, render("<label for=\"title\">Title</label><input type=\"text\" id=\"title\" />"));
        return promise.then(function (actual) {
                    return Promise.resolve(JestDom.toBeInTheDocument(expect(actual)));
                  });
      }));

Jest.testPromise("findByText", undefined, (function (param) {
        var promise = DomTestingLibrary.findByText(undefined, {
              NAME: "Str",
              VAL: "Hello world"
            }, render("<span>Hello world</span>"));
        return promise.then(function (el) {
                    return Promise.resolve(JestDom.toBeInTheDocument(expect(el)));
                  });
      }));

Jest.testPromise("findByRole", undefined, (function (param) {
        var options = DomTestingLibrary.makeOptions(undefined, undefined, "Red Color", undefined);
        var promise = DomTestingLibrary.findByRole(options, {
              NAME: "Str",
              VAL: "option"
            }, render("<option role=\"option\">Red Color</option>"));
        return promise.then(function (el) {
                    return Promise.resolve(JestDom.toBeInTheDocument(expect(el)));
                  });
      }));

Jest.testPromise("findAllByRole", undefined, (function (param) {
        var promise = DomTestingLibrary.findAllByRole(undefined, {
              NAME: "Str",
              VAL: "option"
            }, render("<select>\n    <option role=\"option\">Color Red</option>\n    <option role=\"option\">Color Green</option>\n    <option role=\"option\">Color Blue</option>\n  </select>"));
        return promise.then(function (el) {
                    return Promise.resolve(Jest.Expect.toHaveLength(3, Jest.Expect.expect(el)));
                  });
      }));

Jest.testPromise("findByPlaceholderText", undefined, (function (param) {
        var promise = DomTestingLibrary.findByPlaceholderText(undefined, {
              NAME: "Str",
              VAL: "title"
            }, render("<input type=\"text\" placeholder=\"title\" />"));
        return promise.then(function (el) {
                    return Promise.resolve(JestDom.toBeInTheDocument(expect(el)));
                  });
      }));

Jest.testPromise("findByDisplayValue", undefined, (function (param) {
        var promise = DomTestingLibrary.findByDisplayValue(undefined, {
              NAME: "Str",
              VAL: "Red"
            }, render("<input type=\"text\" placeholder=\"title\" value=\"Red\" />"));
        return promise.then(function (el) {
                    return Promise.resolve(JestDom.toBeInTheDocument(expect(el)));
                  });
      }));

Jest.testPromise("findByAltText", undefined, (function (param) {
        var promise = DomTestingLibrary.findByAltText(undefined, {
              NAME: "Str",
              VAL: "alt text example"
            }, render("<img alt=\"alt text example\" />"));
        return promise.then(function (el) {
                    return Promise.resolve(JestDom.toBeInTheDocument(expect(el)));
                  });
      }));

Jest.testPromise("findByTitle", undefined, (function (param) {
        var promise = DomTestingLibrary.findByTitle(undefined, {
              NAME: "Str",
              VAL: "title example"
            }, render("<span title=\"title example\" />"));
        return promise.then(function (el) {
                    return Promise.resolve(JestDom.toBeInTheDocument(expect(el)));
                  });
      }));

Jest.testPromise("findByTestId", undefined, (function (param) {
        var promise = DomTestingLibrary.findByTestId(undefined, {
              NAME: "Str",
              VAL: "test-id"
            }, render("<div data-testid=\"test-id\">Test ID</div>"));
        return promise.then(function (el) {
                    return Promise.resolve(JestDom.toBeInTheDocument(expect(el)));
                  });
      }));

Jest.testPromise("waitFor", undefined, (function (param) {
        return DomTestingLibrary.waitFor(function (param) {
                    return JestDom.toBeInTheDocument(expect(DomTestingLibrary.getByTestId(undefined, {
                                        NAME: "Str",
                                        VAL: "test-id"
                                      }, renderWithDelay("<div data-testid=\"test-id\">Test ID</div>", 200))));
                  });
      }));

var HaveClass = JestDom.HaveClass;

var TextContent = JestDom.TextContent;

var toBeDisabled = JestDom.toBeDisabled;

var toBeEnabled = JestDom.toBeEnabled;

var toBeEmpty = JestDom.toBeEmpty;

var toBeEmptyDOMElement = JestDom.toBeEmptyDOMElement;

var toBeInTheDocument = JestDom.toBeInTheDocument;

var toBeInvalid = JestDom.toBeInvalid;

var toBeRequired = JestDom.toBeRequired;

var toBeValid = JestDom.toBeValid;

var toBeVisible = JestDom.toBeVisible;

var toContainElement = JestDom.toContainElement;

var toContainHTML = JestDom.toContainHTML;

var toHaveAttribute = JestDom.toHaveAttribute;

var toHaveClass = JestDom.toHaveClass;

var toHaveFocus = JestDom.toHaveFocus;

var toHaveFormValues = JestDom.toHaveFormValues;

var toHaveStyle = JestDom.toHaveStyle;

var toHaveTextContent = JestDom.toHaveTextContent;

var toHaveValue = JestDom.toHaveValue;

var toHaveDisplayValue = JestDom.toHaveDisplayValue;

var toBeChecked = JestDom.toBeChecked;

var toBePartiallyChecked = JestDom.toBePartiallyChecked;

var toHaveDescription = JestDom.toHaveDescription;

exports.HaveClass = HaveClass;
exports.TextContent = TextContent;
exports.toBeDisabled = toBeDisabled;
exports.toBeEnabled = toBeEnabled;
exports.toBeEmpty = toBeEmpty;
exports.toBeEmptyDOMElement = toBeEmptyDOMElement;
exports.toBeInTheDocument = toBeInTheDocument;
exports.toBeInvalid = toBeInvalid;
exports.toBeRequired = toBeRequired;
exports.toBeValid = toBeValid;
exports.toBeVisible = toBeVisible;
exports.toContainElement = toContainElement;
exports.toContainHTML = toContainHTML;
exports.toHaveAttribute = toHaveAttribute;
exports.toHaveClass = toHaveClass;
exports.toHaveFocus = toHaveFocus;
exports.toHaveFormValues = toHaveFormValues;
exports.toHaveStyle = toHaveStyle;
exports.toHaveTextContent = toHaveTextContent;
exports.toHaveValue = toHaveValue;
exports.toHaveDisplayValue = toHaveDisplayValue;
exports.toBeChecked = toBeChecked;
exports.toBePartiallyChecked = toBePartiallyChecked;
exports.toHaveDescription = toHaveDescription;
exports.render = render;
exports.renderWithDelay = renderWithDelay;
exports.$$Promise = $$Promise;
/*  Not a pure module */
